/* Note: Uses Payments tables which is not part of Northwind 
as supplied.  See separate .SQL file to create it */

SELECT
  O.CustomerID,
  O.OrderID,  
  O.OrderAmount,  
  SUM(P.Amount)AS PaidAmount
FROM
(
SELECT
  O.CustomerID,
  O.OrderID,  
  SUM(D.UnitPrice*D.Quantity)AS OrderAmount
FROM
  Orders O
  LEFT JOIN [Order Details] D ON D.OrderID=O.OrderID
WHERE
  O.ShippedDate IS NOT NULL
GROUP BY
  O.CustomerID,
  O.OrderID
) O
  LEFT JOIN Payments P ON P.OrderID=O.OrderID
GROUP BY
  O.CustomerID,
  O.OrderID,  
  O.OrderAmount
HAVING
  ISNULL(SUM(P.Amount),0)<O.OrderAmount


SELECT
  O.CustomerID,
  O.OrderID,  
  D.OrderAmount,  
  SUM(P.Amount)AS PaidAmount
FROM
  Orders O
  LEFT JOIN Payments P ON P.OrderID=O.OrderID
  LEFT JOIN 
   (SELECT
     OrderID,
     SUM(UnitPrice*Quantity)AS OrderAmount
    FROM
     [Order Details]
    GROUP BY
     OrderID
    )D ON D.OrderID=O.OrderID
WHERE
  O.ShippedDate IS NOT NULL
GROUP BY
  O.CustomerID,
  O.OrderID,
  D.OrderAmount
HAVING
  ISNULL(SUM(P.Amount),0)<ISNULL(D.OrderAmount,0)


SELECT
  O.CustomerID,
  O.OrderID,  
  D.OrderAmount,  
  P.PaidAmount
FROM
  Orders O
  LEFT JOIN 
    (SELECT
       OrderID,
       SUM(Amount)AS PaidAmount
     FROM	   
       Payments
     GROUP BY
       OrderID
     ) P ON P.OrderID=O.OrderID
  LEFT JOIN 
   (SELECT
     OrderID,
     SUM(UnitPrice*Quantity)AS OrderAmount
    FROM
     [Order Details]
    GROUP BY
     OrderID
    )D ON D.OrderID=O.OrderID
WHERE
  O.ShippedDate IS NOT NULL AND
  ISNULL(P.PaidAmount,0)<ISNULL(D.OrderAmount,0)


/*  The following query will give the wrong result.
Can you see why?
(Consider an order with two Order Detail and two Payment records)

SELECT
  O.CustomerID,
  O.OrderID,  
  SUM(D.UnitPrice*D.Quantity)AS OrderAmount,
  SUM(P.Amount)AS PaidAmount
FROM
  Orders O
  LEFT JOIN [Order Details] D ON D.OrderID=O.OrderID
  LEFT JOIN Payments P ON P.OrderID=O.OrderID
GROUP BY
  O.CustomerID,
  O.OrderID
HAVING
  ISNULL(SUM(P.Amount),0)<SUM(D.UnitPrice*D.Quantity)

*/